
%define pykde4_akonadi 1
%define pyqt4_version_min 4.8.2
%define sip_version_min 4.12
%global python_ver %(%{__python} -c "import sys ; print sys.version[:3]")

Name: PyKDE4 
Version: 4.7.4
Release: 1%{?dist}
Summary: Python bindings for KDE4 

# http://techbase.kde.org/Policies/Licensing_Policy
License: LGPLv2+
Group: User Interface/Desktops
URL: http://developer.kde.org/language-bindings/
Source0: ftp://ftp.kde.org/pub/kde/stable/%{version}/src/pykde4-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  kdebase-workspace-devel >= %{version}
BuildRequires:  kdelibs4-devel >= %{version}
BuildRequires:  kdepimlibs-devel >= %{version}
BuildRequires:  pkgconfig(akonadi)
BuildRequires:  pkgconfig(python)
BuildRequires:  pkgconfig(qimageblitz)
BuildRequires:  pkgconfig(soprano)
BuildRequires:  PyQt4-devel >= %{pyqt4_version_min}, sip-devel >= %{sip_version_min}
%if 0%{?python3}
BuildRequires:  python3-devel
BuildRequires:  python3-PyQt4-devel >= %{pyqt4_version_min}, python3-sip-devel >= %{sip_version_min}
%global python3_inc %(%{__python3} -c "from distutils.sysconfig import get_python_inc; print(get_python_inc(1))")
%global python3_ver %(%{__python3} -c "import sys ; print (\\"%s%s\\" % (sys.version[:3],getattr(sys,'abiflags','')))")
%global python3_pyqt4_version %(%{__python3} -c 'import PyQt4.pyqtconfig; print(PyQt4.pyqtconfig._pkg_config["pyqt_version_str"])' 2> /dev/null || echo %{pyqt4_version_min})
%endif
%if 0%{?fedora}
BuildRequires:  qscintilla-devel >= 2.4
%endif

## FIXME/TODO
#-- The following OPTIONAL packages could NOT be located on your system.
#-- Consider installing them to enable more features from this software.
#-----------------------------------------------------------------------------
#   * Qwt5 for Qt4  <http://qwt.sourceforge.net>
#     Qwt5 libraries for Qt4
#     Needed to compile Qwt5 bindings

Requires: kdelibs4%{?_isa} >= %{version}
Requires: kate-part%{?_isa} >= %{version}
%global pyqt4_version %(%{__python} -c 'import PyQt4.pyqtconfig; print(PyQt4.pyqtconfig._pkg_config["pyqt_version_str"])' 2> /dev/null || echo %{pyqt4_version_min})
Requires: PyQt4 >= %{pyqt4_version}
%{?_sip_api:Requires: sip-api(%{_sip_api_major}) >= %{_sip_api}}
%if ! 0%{?pykde4_akonadi}
Provides: PyKDE4-akonadi%{?_isa} = %{version}-%{release}
Provides: pykde4-akonadi%{?_isa} = %{version}-%{release}
Requires: kdepimlibs-akonadi%{?_isa} >= %{version}
%endif

Provides: pykde4 = %{version}-%{release}
Provides: pykde4%{?_isa} = %{version}-%{release}

%description
%{summary}.

%package akonadi
Summary: Akonadi runtime support for %{name} 
Group: Development/Languages 
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: kdepimlibs-akonadi%{?_isa} >= %{version} 
Provides: pykde4-akonadi = %{version}-%{release}
Provides: pykde4-akonadi%{?_isa} = %{version}-%{release}
%description akonadi 
%{summary}.

%package devel
Group:    Development/Languages
Summary:  Files needed to build %{name}-based applications
Requires: PyQt4-devel
Requires: %{name}%{?_isa} = %{version}-%{release}
%if 0%{?pykde4_akonadi}
Requires: %{name}-akonadi%{?_isa} = %{version}-%{release}
%endif
Provides: pykde4-devel = %{version}-%{release}
Provides: pykde4-devel%{?_isa} = %{version}-%{release}
%description devel
%{summary}.

%package -n python3-PyKDE4
Summary: Python 3 bindings for KDE 
Group:   Development/Languages
Requires: python3-PyQt4 >= %{python3_pyqt4_version}
%{?_sip_api:Requires: python3-sip-api(%{_sip_api_major}) >= %{_sip_api}}
%if ! 0%{?pykde4_akonadi}
Provides: python3-PyKDE4-akonadi%{?_isa} = %{version}-%{release}

Requires: kdepimlibs-akonadi%{?_isa} >= %{version}
%endif
Provides: python3-pykde4 = %{version}-%{release}
Provides: python3-pykde4%{?_isa} = %{version}-%{release}
%description -n python3-PyKDE4
%{summary}.

%package -n python3-PyKDE4-akonadi
Summary: Akonadi runtime support for %{name} 
Group: Development/Languages
Requires: python3-PyKDE4%{?_isa} = %{version}-%{release}
Requires: kdepimlibs-akonadi%{?_isa} >= %{version}
Provides: python3-pykde4-akonadi = %{version}-%{release}
Provides: python3-pykde4-akonadi%{?_isa} = %{version}-%{release}
%description -n python3-PyKDE4-akonadi
%{summary}.

%package -n python3-PyKDE4-devel
Group:    Development/Languages
Summary:  Files needed to build %{name}-based applications
Requires: python3-PyQt4-devel
Requires: python3-PyKDE4%{?_isa} = %{version}-%{release}
%if 0%{?pykde4_akonadi}
Requires: python3-PyKDE4-akonadi%{?_isa} = %{version}-%{release}
%endif
Provides: python3-pykde4-devel = %{version}-%{release}
Provides: python3-pykde4-devel%{?_isa} = %{version}-%{release}
%description -n python3-PyKDE4-devel
%{summary}.


%prep
%setup -q -n pykde4-%{version}


%build
%if 0%{?python3}
mkdir -p %{_target_platform}-python3
pushd    %{_target_platform}-python3
%{cmake_kde4} \
  -DPYTHON_EXECUTABLE:PATH=%{__python3} \
  -DPython_ADDITIONAL_VERSIONS=%{python3_ver} \
  -DPYTHON_LIBRARY=%{_libdir}/libpython%{python3_ver}.so.1.0 \
  -DPYTHON_LIBRARIES=%{_libdir}/libpython%{python3_ver}.so.1.0 \
  -DPYTHON_INCLUDE_PATH=%{_includedir}/python%{python3_ver} \
  ..

make %{?_smp_mflags} -C python/
popd
%endif

mkdir -p %{_target_platform}
pushd %{_target_platform}
%{cmake_kde4} \
  -DPYTHON_LIBRARY=%{_libdir}/libpython%{python_ver}.so.1.0 \
  -DPYTHON_LIBRARIES=%{_libdir}/libpython%{python_ver}.so.1.0 \
  -DPYTHON_INCLUDE_PATH=%{_includedir}/python%{python_ver} \
  ..
  
  make %{?_smp_mflags}
popd
 


%install
rm -rf %{buildroot}

%if 0%{?python3}
make install/fast DESTDIR=%{buildroot} -C %{_target_platform}-python3/python/

# not python3 compat yet
rm -fv %{buildroot}%{_kde4_libdir}/kde4/kpythonpluginfactory.so 

# HACK: fix multilib conflict, similar to PyQt4's http://bugzilla.redhat.com/509415
rm -fv %{buildroot}%{_bindir}/pykdeuic4
mv %{buildroot}%{python3_sitearch}/PyQt4/uic/pykdeuic4.py \
   %{buildroot}%{_bindir}/python3-pykdeuic4
ln -s %{_bindir}/python3-pykdeuic4 \
      %{buildroot}%{python3_sitearch}/PyQt4/uic/pykdeuic4.py

# install pykde4 examples under correct dir
mkdir -p %{buildroot}%{_docdir}
rm -fv %{buildroot}%{_kde4_appsdir}/pykde4/examples/*.py?
mv %{buildroot}%{_kde4_appsdir}/pykde4 %{buildroot}%{_docdir}/python3-pykde4
%endif

make install/fast DESTDIR=%{buildroot} -C %{_target_platform}

# HACK: fix multilib conflict, similar to PyQt4's http://bugzilla.redhat.com/509415
rm -fv %{buildroot}%{_bindir}/pykdeuic4
mv %{buildroot}%{python_sitearch}/PyQt4/uic/pykdeuic4.py \
   %{buildroot}%{_bindir}/pykdeuic4
ln -s %{_bindir}/pykdeuic4 \
      %{buildroot}%{python_sitearch}/PyQt4/uic/pykdeuic4.py

# install pykde4 examples under correct dir
mkdir -p %{buildroot}%{_docdir}
rm -fv %{buildroot}%{_kde4_appsdir}/pykde4/examples/*.py?
mv %{buildroot}%{_kde4_appsdir}/pykde4 %{buildroot}%{_docdir}/


%clean
rm -rf %{buildroot}


%files 
%defattr(-,root,root,-)
%{python_sitearch}/PyKDE4/
%{python_sitearch}/PyQt4/uic/widget-plugins/kde4.py*
%dir %{_docdir}/pykde4
%{_kde4_libdir}/kde4/kpythonpluginfactory.so

%if 0%{?pykde4_akonadi}
%exclude %{python_sitearch}/PyKDE4/akonadi.so
%files akonadi
%defattr(-,root,root,-)
%{python_sitearch}/PyKDE4/akonadi.so
%endif

%files devel
%defattr(-,root,root,-)
%{_kde4_bindir}/pykdeuic4
%{python_sitearch}/PyQt4/uic/pykdeuic4.py*
%{_docdir}/pykde4/examples/
%{_kde4_datadir}/sip/PyKDE4/

%if 0%{?python3}
%files -n python3-PyKDE4
%defattr(-,root,root,-)
%doc COPYING
%{python3_sitearch}/PyKDE4/
%{python3_sitearch}/PyQt4/uic/widget-plugins/kde4.py*
%dir %{_docdir}/python3-pykde4

%if 0%{?pykde4_akonadi}
%exclude %{python3_sitearch}/PyKDE4/akonadi.so
%files -n python3-PyKDE4-akonadi
%defattr(-,root,root,-)
%{python3_sitearch}/PyKDE4/akonadi.so
%endif

%files -n python3-PyKDE4-devel
%defattr(-,root,root,-)
%{_kde4_bindir}/python3-pykdeuic4
%{python3_sitearch}/PyQt4/uic/pykdeuic4.py*
%{_docdir}/python3-pykde4/examples/
%{_kde4_datadir}/python3-sip/PyKDE4/
%endif


%changelog
* Fri Dec 02 2011 Rex Dieter <rdieter@fedoraproject.org> 4.7.4-1
- 4.7.4

* Thu Nov 10 2011 Rex Dieter <rdieter@fedoraproject.org> 4.7.3-1.1
- rebuild (sip/PyQt4)

* Sat Oct 29 2011 Rex Dieter <rdieter@fedoraproject.org> 4.7.3-1
- 4.7.3
- pkgconfig-style deps
- Provides: pykde4
- tighten subpkg deps via %%_isa

* Sat Oct 08 2011 Rex Dieter <rdieter@fedoraproject.org> 4.7.2-2
- Requires: kate-part

* Tue Oct 04 2011 Rex Dieter <rdieter@fedoraproject.org> 4.7.2-1
- 4.7.2

* Fri Sep 16 2011 Rex Dieter <rdieter@fedoraproject.org> 4.7.1-2
- drop BR: kdesdk-devel/kate-devel kdegraphics-devel/okular-devel

* Wed Sep 14 2011 Radek Novacek <rnovacek@redhat.com> 4.7.1-1
- 4.7.1

* Tue Jul 26 2011 Jaroslav Reznik <jreznik@redhat.com> 4.7.0-1
- 4.7.0

* Fri Jul 08 2011 Rex Dieter <rdieter@fedoraproject.org> 4.6.95-1
- 4.6.95

* Thu Jul 07 2011 Rex Dieter <rdieter@fedoraproject.org> 4.6.90-1
- first try

